# -*- coding: utf-8 -*-

"""
    Greek Voice Add-on
    Author: Twilight

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import os, sys
import urllib2, urlparse
import xbmc, xbmcaddon, xbmcgui, xbmcplugin


# Commands:
join = os.path.join
addon = xbmcaddon.Addon

language = addon().getLocalizedString
addonname = addon().getAddonInfo("name")
addonid = addon().getAddonInfo("id")
addonpath = addon().getAddonInfo("path")
addonfanart = addon().getAddonInfo("fanart")
addonicon = addon().getAddonInfo("icon")
addonmedia = join(addon('script.greekvoice.artwork').getAddonInfo('path'), 'resources', 'media')
addDirItem = xbmcplugin.addDirectoryItem
addDirItems = xbmcplugin.addDirectoryItems
endDir = xbmcplugin.endOfDirectory
dialog = xbmcgui.Dialog()
condVisibility = xbmc.getCondVisibility
execute = xbmc.executebuiltin

# Handlers:
addon_url = sys.argv[0]
addon_handle = int(sys.argv[1])
params = dict(urlparse.parse_qsl(sys.argv[2][1:]))
action = params.get('action')
url = params.get('url')

items = [
    {
        'title': 'Greek Voice',
        'icon': join(addonmedia, 'GV1_icon.png'),
        'url': 'http://iphone-streaming.ustream.tv/uhls/1989576/streams/live/iphone/playlist.m3u8',
        'fanart': join(addonmedia, 'GV_TV1_fanart.jpg'),
        'plot': 'Greek Voice 1'.decode('utf-8')
    },
    # {
    #     'title': 'Greek Voice 2',
    #     'icon': join(addonmedia, 'GV2_icon.png'),
    #     'url': 'http://stream.ssh101.com:1935/live/greekvoice/playlist.m3u8',
    #     'fanart': join(addonmedia, 'GV_TV2_fanart.jpg'),
    #     'plot': 'Greek Voice 2'.decode('utf-8')
    # },
    {
        'title': 'TILEMOUSIKI 1 SD',
        'icon': join(addonmedia, 'TILEMOUSIKI1SD.png'),
        'url': 'mmsh://wpso.com:200/music',
        'fanart': join(addonmedia, 'TILEMOUSIKI_fanart.jpg'),
        'plot': 'Εκπέμπει Παλαιά Τραγούδια και κονσέρτα σε ποιότητα SD'.decode('utf-8')
    },
    {
        'title': 'TILEMOUSIKI 2 HD',
        'icon': join(addonmedia, 'TILEMOUSIKI2HD.png'),
        'url': 'http://iphone-streaming.ustream.tv/uhls/18655753/streams/live/iphone/playlist.m3u8',
        'fanart': join(addonmedia, 'TILEMOUSIKI_fanart.jpg'),
        'plot': 'Μουσικό κανάλι εκπέμπει 24/7 σε σύστημα HD'.decode('utf-8')
    },
    {
        'title': 'WZRA KIDS 1',
        'icon': join(addonmedia, 'WZRA_KIDS_icon.png'),
        'url': 'mmsh://wpso.com:200/kids',
        'fanart': addonfanart,
        'plot': 'Παιδικό Κανάλι 24/7'.decode('utf-8')
    },
{
        'title': 'WZRA KIDS 2',
        'icon': join(addonmedia, 'WZRA_KIDS_icon.png'),
        'url': 'http://iphone-streaming.ustream.tv/uhls/22988956/streams/live/iphone/playlist.m3u8',
        'fanart': addonfanart,
        'plot': 'Παιδικό Κανάλι 24/7'.decode('utf-8')
    },
    {
        'title': 'WPSO Greek Voice Radio',
        'icon': join(addonmedia, 'wpso_icon.png'),
        'url': 'http://wpso.com:8000/',
        'fanart': join(addonmedia, 'GV_Radio_fanart.jpg'),
        'plot': 'Ραδιοφωνικός σταθμός Φωνή Των Ελλήνων, παγκοσμία κάλυψη'.decode('utf-8')
    },
    {
        'title': 'WXYB Radio GR IT ES',
        'icon': join(addonmedia, 'wxyb_icon.png'),
        'url': 'http://wpso.com:7071/',
        'fanart': join(addonmedia, 'GV_Radio_fanart.jpg'),
        'plot': 'Radio WXYB 1520Khz Greek Italian & Spanish'
    },
    {
        'title': 'XAMOS Youth Radio',
        'icon': join(addonmedia, 'xamos_icon.png'),
        'url': 'http://xamosam.com:9050',
        'fanart': join(addonmedia, 'xamos_fanart.jpg'),
        'plot': 'XAMOS Youth Radio 1500 KHz AM'
    }
]


# Build Root Menu:
def main_menu():

    tv_item_list = []
    radio_item_list = []

    _list_item = xbmcgui.ListItem(label=language(30001), iconImage=addonicon)
    _list_item.setInfo('video', {'title': language(30001)})
    _list_item.setArt({'fanart': addonfanart})
    addDirItem(handle=addon_handle, url=None, listitem=_list_item, isFolder=False)

    for item in items[:5]:
        _list_item = xbmcgui.ListItem(label=item['title'], iconImage=item['icon'])
        _list_item.setInfo(type='video', infoLabels={'title': item['title'], 'plot': item['plot']})
        _list_item.setArt({'thumb': item['icon'], 'fanart': item['fanart']})
        _list_item.setProperty('IsPlayable', 'true')
        _url = '{0}?action=play&url={1}'.format(addon_url, item['url'])
        _isFolder = False
        tv_item_list.append((_url, _list_item, _isFolder))

    addDirItems(addon_handle, tv_item_list, len(tv_item_list))

    _list_item = xbmcgui.ListItem(label=language(30002))
    _list_item.setInfo('video', {'title': language(30002)})
    _list_item.setArt({'icon': addonicon, 'fanart': addonfanart})
    addDirItem(handle=addon_handle, url=None, listitem=_list_item, isFolder=False)

    for item in items[5:]:
        _list_item = xbmcgui.ListItem(label=item['title'], iconImage=item['icon'])
        _list_item.setInfo('audio', {'title': item['title'], 'plot': item['plot']})
        _list_item.setArt({'thumb': item['icon'], 'fanart': item['fanart']})
        _list_item.setProperty('IsPlayable', 'true')
        _url = '{0}?action=play&url={1}'.format(addon_url, item['url'])
        _isFolder = False
        radio_item_list.append((_url, _list_item, _isFolder))

    addDirItems(addon_handle, radio_item_list, len(radio_item_list))

    _list_item = xbmcgui.ListItem(label=language(30003), iconImage=addonicon)
    _list_item.setInfo('video', {'title': language(30003)})
    _list_item.setArt({'fanart': addonfanart})
    addDirItem(handle=addon_handle, url=None, listitem=_list_item, isFolder=False)

    youtube_channel = 'plugin://plugin.video.youtube/channel/UC0HzJJlSxjhhN4OAXHHQIOg/'
    _list_item = xbmcgui.ListItem(label='Youtube Channel')
    _list_item.setInfo('video', {'title': 'Youtube Channel'})
    _list_item.setArt({'icon': join(addonmedia, 'GV_YT_icon.png'), 'fanart': addonfanart})
    addDirItem(handle=addon_handle, url=youtube_channel, listitem=_list_item, isFolder=True)

    guide_url = '{0}?action=guide'.format(addon_url)
    _list_item = xbmcgui.ListItem(label='TV Guide', iconImage=join(addonmedia, 'tvguide_icon.png'))
    _list_item.setInfo('video', {'title': 'TV Guide'})
    _list_item.setArt({'fanart': addonfanart})
    addDirItem(handle=addon_handle, url=guide_url, listitem=_list_item, isFolder=False)

    settings_url = '{0}?action=settings'.format(addon_url)
    _list_item = xbmcgui.ListItem(label=language(30004), iconImage=join(addonmedia, 'settings.png'))
    _list_item.setInfo('video', {'title': language(30004)})
    _list_item.setArt({'fanart': addonfanart})
    addDirItem(handle=addon_handle, url=settings_url, listitem=_list_item, isFolder=False)

    endDir(addon_handle)


def play_item(url):

    list_item = xbmcgui.ListItem(path=url)
    xbmcplugin.setResolvedUrl(addon_handle, True, listitem=list_item)


def txt_box(heading, announce):

    window_id = 10147
    control_id1 = 1
    control_id2 = 5
    gui_window = xbmcgui.Window(window_id)

    execute('ActivateWindow(%d)' % window_id)
    xbmc.sleep(200)

    gui_window.getControl(control_id1).setLabel(heading)

    gui_window.getControl(control_id2).setText(announce)


def requester(url):

    requester = urllib2.Request(url)
    requester.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.3; rv:36.0) Gecko/20100101 Firefox/36.04')
    response = urllib2.urlopen(requester)
    result = response.read()
    response.close()

    return result


def guide():

    raw = requester('http://pastebin.com/raw/8euL4fNM')

    txt_box('Greek Voice TV Guide', raw)


def youtube():

    # Please do not copy these keys, instead create your own with this tutorial:
    # http://forum.kodi.tv/showthread.php?tid=267160&pid=2299960#pid2299960

    api_keys = {
        'enablement': 'true',
        'id': '498788153161-pe356urhr0uu2m98od6f72k0vvcdsij0.apps.googleusercontent.com',
        'api_key': 'AIzaSyA8k1OyLGf03HBNl0byD511jr9cFWo2GR4',
        'secret': 'e6RBIFCVh1Fm-IX87PVJjgUu'
    }

    def yt_setup(lang):

        if addon('plugin.video.youtube').getSetting('youtube.api.enable') == 'true':
            if dialog.yesno(heading=addonname, line1=language(30007), line2=language(30008)):
                addon('plugin.video.youtube').setSetting('youtube.api.enable', api_keys['enablement'])
                addon('plugin.video.youtube').setSetting('youtube.api.id', api_keys['id'])
                addon('plugin.video.youtube').setSetting('youtube.api.key', api_keys['api_key'])
                addon('plugin.video.youtube').setSetting('youtube.api.secret', api_keys['secret'])
                dialog.notification(heading=addonname, message=language(30009), time=3000, sound=False)
            else:
                dialog.notification(heading=addonname, message=language(30010), time=3000, sound=False)
        else:
            if dialog.yesno(heading=addonname, line1=language(lang), line2=language(30008)):
                addon('plugin.video.youtube').setSetting('youtube.api.enable', api_keys['enablement'])
                addon('plugin.video.youtube').setSetting('youtube.api.id', api_keys['id'])
                addon('plugin.video.youtube').setSetting('youtube.api.key', api_keys['api_key'])
                addon('plugin.video.youtube').setSetting('youtube.api.secret', api_keys['secret'])
                dialog.notification(heading=addonname, message=language(30009), time=3000, sound=False)
            else:
                dialog.notification(heading=addonname, message=language(30010), time=3000, sound=False)

    if condVisibility('System.HasAddon(plugin.video.youtube)'):

        yt_setup(30011)

    else:

        if dialog.yesno(heading=addonname, line1=language(30012), line2=language(30008)):
            execute('InstallAddon(plugin.video.youtube)')
            yt_setup(30013)
        else:
            dialog.notification(heading=addonname, message=language(30010), time=3000, sound=False)


if action is None:
    main_menu()

elif action == 'play':
    play_item(url)

elif action == 'guide':
    guide()

elif action == 'settings':
    addon().openSettings()

elif action == 'youtube':
    youtube()
